#include "colors.inc"
#include "textures.inc"
#include "metals.inc"
#include "woods.inc"     

//#declare skip=1;
//#declare skiptree=1;
//#declare skipgrass=1;
#global_settings { ambient_light  rgb <.975,.9675,.8123>}
    
  camera {  
    location <-115, 160, 220>
    look_at <-240,-80,180>
    angle 45             
  }    
    
  light_source { <-100,880,105> rgb <.97,.97,.93>*.4
                 area_light x*30,z*30,6,6
                 }                

  light_source { <-650,880,105> rgb <.97,.97,.93>*.4
                 area_light x*30,z*30,6,6
                 }                

  light_source { <-650,880,1055> rgb <.97,.97,.93>*.4
                 area_light x*30,z*30,6,6
                 }                

  light_source { <-250,200,355> Gray60
                   area_light x*120,y*100,8,8
                   jitter
                   adaptive 1
                 }

  light_source { <-230,-110,110> Gray15
                 area_light x*4,z*4,5,5
                 }

  light_source { <-240,-120,215> Gray15
                   area_light x*15,z*15,5,5
                   jitter
                   adaptive 1
                }
// Desk

                                                 
#declare EnamelInterior= interior{
                            ior 1.5
                            fade_distance .4
                            fade_power 4
                        }

#declare EnamelFinish=finish {
    ambient 0.3
    diffuse 0.5
    reflection .05
    reflection_exponent 0.5   
    brilliance 1.8
    specular .15
    roughness 0.64
}

#declare EColor1=pigment {rgb <0.93,0.91,0.8>}
#declare EColor2=pigment {rgb <0.83,0.81,0.7>}
#declare EColor3=pigment {rgb <0.88,0.86,0.75>}

#declare EnamelColor=pigment_map {         
                        [   0.0 EColor1 ]
                        [   0.3 EColor1 ]
                        [   0.4 EColor3 ]
                        [   0.5 EColor1 ]
                        [   0.67 EColor1 ]
                        [   0.77 EColor2]
                        [   0.87 EColor1]
                        [   1   EColor1 ]
                        }  

#declare Handle=object {
intersection {
    union {
        box { <-2.125,-0.125,-0.0625>,
              <2.125, 0.125, 0.0625>
            }
        box { <-.25,-.125,-.5>,
              <.25,.125,.5>
              rotate 10*y
              translate <-2,0,-0.5>
            }
        box { <-.25,-.125,-.5>,
              <.25,.125,.5>
              rotate -10*y
              translate <2,0,-.5>
            }
        cylinder { <-2.125,-0.125, 0.03125>,
                   <-2.125, 0.125, 0.03125>,
                    .03125
                 }
        cylinder {  <2.125,-0.125, 0.03125>,
                    <2.125, 0.125, 0.03125>,
                    .03125
                 }
         }
   box { <-2.45,-0.135,-0.95>,
         <2.45, .135, 0.063>
         }
     }                                          
     texture {T_Chrome_5E}
}
#declare Thk=0.006;
#declare CylThk=Thk*1.1;
#declare FrontWidth=7.4875;
#declare FrontHeight=2.8;
#declare Edge1=difference{
                box { < 0,-Thk,0.1875>,
                      <14.974,Thk,-.1875>
                    }
                box { <-0.1,-Thk*2,0.2>
                      <0.01,Thk*2,-.2>
                      rotate y*-3  
                    }
                box { <-0.01,-Thk*2,0.2>
                      <0.1,Thk*2,-.2>
                      rotate y*3  
                      translate <14.974,0,0>
                    }
               }

#declare Edge2=difference {
                box { < -Thk,-2.775,0.1875>,
                      <Thk,2.775,-.1875>
                    }
                box { <-Thk*2,0.01,0.2>
                      <Thk*2,-0.1,-.2>
                      rotate x*-3
                      translate -2.775  
                    }
                box { <-Thk*2,-0.01,0.2>
                      <Thk*2,0.1,-.2>
                      rotate x*3
                      translate 2.775  
                    }
               }

#declare DrawerFront=object {
    union {
        box { <-FrontWidth,-2.8,-Thk>,
              < FrontWidth, 2.8, Thk>
            }
        object { Edge1 
                 translate <-FrontWidth+.00025,FrontHeight+CylThk-Thk,-0.1875-CylThk>
               }
        object { Edge2
                 translate <-FrontWidth+.00025+CylThk,0,-0.1875-CylThk>
               }
        object { Edge2
                 translate <FrontWidth-.00025-CylThk,0,-0.1875-CylThk>
               }
        cylinder { <-FrontWidth+CylThk*2,-2.775,-CylThk*2>,
                   <-FrontWidth+CylThk*2,2.775,-CylThk*2>,
                   CylThk*3
                 }
        cylinder { <FrontWidth,-2.775,-CylThk>,
                   <FrontWidth,2.775,-CylThk>,
                   CylThk*3
                 }
        cylinder { <-FrontWidth,-2.8+CylThk*2,-CylThk*2>,
                   <FrontWidth,-2.8+CylThk*2,-CylThk*2>,
                   CylThk*3
                 }
        cylinder { <-FrontWidth,2.8-CylThk*2,-CylThk*2>,
                   <FrontWidth,2.8-CylThk*2,-CylThk*2>,
                   CylThk*3
                 }
        }
    }

#declare Side=union {
    difference {
        box {<FrontWidth-0.5,FrontHeight-0.75,0>,
             <FrontWidth-0.5-Thk,-FrontHeight+0.75,-19.5>}
            #declare Lp1=1.75;
            #declare LpStep=1;
            #declare Lp1Add=.75;
            #declare Lp1Gap=7.5;
            #while (Lp1<14)
                box {<FrontWidth-0.8,FrontHeight-1.5,-Lp1>,
                     <FrontWidth-0.3,FrontHeight-2.25,-Lp1-3/32>
                     }
                
                box {<FrontWidth-0.8,FrontHeight-2.75,-Lp1>,
                     <FrontWidth-0.3,FrontHeight-3.5,-Lp1-3/32>
                     }
                
                #declare Lp1=Lp1+LpStep+Lp1Add;
                #if (Lp1>Lp1Gap) 
                    #declare Lp1Gap=100;
                    #declare LP1Add=0.75;
                #else
                    #declare Lp1Add=0;
                #end
            #end
       } // end difference
       cylinder {<FrontWidth-0.5,FrontHeight-0.7,0>,
                 <FrontWidth-0.5,FrontHeight-0.7,-19.5>
                 0.125}
       box {<FrontWidth-0.5,-FrontHeight+1.5,0>,
            <FrontWidth-0.25,-FrontHeight+1.5-Thk,-19.5>}
            
       cylinder { <FrontWidth-0.25,-FrontHeight+1.5-Thk/2,0>,
                  <FrontWidth-0.25,-FrontHeight+1.5-Thk/2,-19.5>
                  Thk/2 }
    }   

#declare Back=box { <FrontWidth-0.5+Thk/2,FrontHeight-0.75,0>,
                    <-FrontWidth+0.5-Thk/2,-FrontHeight+0.75,-Thk>}

#declare Bottom=box { <FrontWidth-0.2+Thk/2,0,9.75>,
                      <-FrontWidth+0.2-Thk/2,-Thk,-9.75> }

#declare Dirt=box { <FrontWidth-0.05,0,9.75>,
                    <-FrontWidth+0.05,0.05,-9.75>
                    texture { pigment { rgb <.422,.181,.15> }
                              finish { specular .22
                                       roughness .1
                                       ambient .25}
                              normal { bumps .3 scale .032}
                              normal { waves frequency 2.65 scale <4,1,3> turbulence 0.65 translate 10*x translate 15*y}
                            }
                   }

#declare Drawer=union {
    object {Handle scale 10 translate <0,0,9.2>}
    object {DrawerFront scale 10
            texture {pigment 
                        {bozo scale 0.01 turbulence 0.5
                         pigment_map {EnamelColor}}
                    }
            finish {EnamelFinish}
            interior {EnamelInterior}
           }
    object {Side 
                scale 10
                texture {pigment 
                        {bozo scale 0.01 turbulence 0.5
                         pigment_map {EnamelColor}}
                        }
                finish {EnamelFinish}
                interior {EnamelInterior}
            }
    object {Side
                translate <-FrontWidth+0.5,0,9.75>
                rotate y*180 
                translate <-FrontWidth+0.5,0,-9.75>
                scale 10
                texture {pigment 
                        {bozo scale 0.01 turbulence 0.5
                         pigment_map {EnamelColor}}
                    }
                finish {EnamelFinish}
                interior {EnamelInterior}
            }
    object {Back
                translate <0,0,-19.5>
                scale <10,18,10>
                texture {pigment 
                        {bozo scale 0.01 turbulence 0.5
                         pigment_map {EnamelColor}}
                    }
                finish {EnamelFinish}
                interior {EnamelInterior}
            }
    object {Bottom
                translate <0,-FrontHeight+0.75,-9.75>
                scale 10
                texture {pigment 
                        {bozo scale 0.01 turbulence 0.5
                         pigment_map {EnamelColor}}
                    }
                finish {EnamelFinish}
                interior {EnamelInterior}
            }
    }

#declare Drawer2=union {
    object {DrawerFront scale <10,22,10>
            texture {pigment 
                        {bozo scale 0.01 turbulence 0.5
                         pigment_map {EnamelColor}}
                    }
            finish {EnamelFinish}
            interior {EnamelInterior}
           }
    object {Side 
                scale <10,18,10>
                texture {pigment 
                        {bozo scale 0.01 turbulence 0.5
                         pigment_map {EnamelColor}}
                    }
                finish {EnamelFinish}
                interior {EnamelInterior}
                translate <0,-10,0>
            }
    object {Side
                translate <-FrontWidth+0.5,0,9.75>
                rotate y*180 
                translate <-FrontWidth+0.5,-0,-9.75>
                scale <10,18,10>
                texture {pigment 
                        {bozo scale 0.01 turbulence 0.5
                         pigment_map {EnamelColor}}
                    }
                finish {EnamelFinish}
                interior {EnamelInterior}
            }
    object {Back
                translate <0,-2,-19.5>
                scale 10
                texture {pigment 
                        {bozo scale 0.01 turbulence 0.5
                         pigment_map {EnamelColor}}
                    }
                finish {EnamelFinish}
                interior {EnamelInterior}
            }
    object {Bottom
                translate <0,(-FrontHeight+0.75)*2.2,-9.75>
                scale 10
                texture {pigment 
                        {bozo scale 0.01 turbulence 0.5
                         pigment_map {EnamelColor}}
                    }
                finish {EnamelFinish}
                interior {EnamelInterior}
            }
    object { Dirt
                translate <0,(-FrontHeight+0.7501)*2.2,-9.75>
                scale 10
            }                
    object {Handle scale 10 translate <0,0,9.2>}
    }

#declare Leg=superellipsoid { <0.16,0.16>
                             texture {T_Chrome_3C}
                             scale <4,160,4>
                            }

#declare DeskTop=box {<-32,-.50625,-15>,
                      < 32, .50625, 15>   
                      texture {T_Wood15 scale 1.2 rotate y*90 rotate z*3.5 translate <0,.6,4.5> }
                      finish {  reflection 0.0325
                                specular 0.2 roughness 0.65 
                                ambient 0.37
                                diffuse 0.53}
                      scale 10}

#declare DeskFrame=union{
                        difference {
                            box { <-FrontWidth-.75,-9.5,0>,
                                  < FrontWidth+.75, 9.5,-Thk>}
                            box { <-FrontWidth-.05,-9,1>,
                                  < FrontWidth+.05, 9,-1>}    
                            }
                        box { <-FrontWidth-.75-Thk,-9.5,0>,
                              <-FrontWidth-.75, 9.5, -30>}
                        box { < FrontWidth+.75+Thk,-9.5,0>,
                              < FrontWidth+.75, 9.5, -30>}
                        texture {pigment 
                                {bozo scale 0.01 turbulence 0.5
                                 pigment_map {EnamelColor}}
                                }
                        scale 10
                        finish {EnamelFinish}
                        interior {EnamelInterior}
                    }

#declare Lock=difference {
                sphere { <0,0,0> 0.5
                         scale <1,1,0.6>
                         }
                box { <-1,-1,0.2>,
                      <1,1,1>
                    }
                sphere { <0,0,0> 0.25
                         translate <0,0,0.2>
                       }
                box { <-.15,-.025,-1>,
                      <0.22,0.025, 1>
                    }
                texture {T_Chrome_5E}
                translate <0,0,0.2>
                scale 10}

#declare SmallDrawer=union {
                        box { <-10.875,-.625,0>,
                              < 10.875,0.625,-Thk>
                            texture {pigment 
                                    {bozo scale 0.01 turbulence 0.5
                                     pigment_map {EnamelColor}}
                                    }
                            scale 10
                            finish {EnamelFinish}
                            interior {EnamelInterior}
                            }
                        object { Lock}
                     } 

#object {Drawer translate <-225,-20,132>}
#object { Leg translate <-312,-140,128.1>}
#object {DeskTop translate <0,20,0>}
#object {Drawer2 translate <-225,-100,220>}
#object {DeskFrame translate <-225,-80,130>}
#object {SmallDrawer translate <-33,6,133>}
#object { Leg translate <312,-140,128.1>}

#declare WallColor =rgb<0.52, 0.41, 0.39>;
#declare Wall2Color=rgb<.93,.874,.841>;
#declare CeilingColor=rgb<.95,.95,.95>;

#declare Wall=box { <-90,-48,-1>,
                    < 90, 48, 1>
                    scale 10
                  }

#declare Wall2=box { <-78,-48,-1>,
                    < 78, 48, 1>
                    texture { pigment { color Wall2Color}
                             finish {ambient 0.4
                                     diffuse 0.4}
                            }
                    scale 10
                    normal {bozo turbulence 0.3 }
                  }

#object {Wall translate <-360,330,480>
            texture { pigment { color DustyRose}
                 finish {ambient 0.4
                         diffuse 0.4}
                        }
            }
#object {Wall translate <-360,330,-1080>
            texture { pigment { color Wall2Color}
                     finish {ambient 0.4
                             diffuse 0.4}
                    }
        }
#object {Wall2 rotate y*90 translate <360,330,-540>}
#object {Wall2 rotate y*90 translate <-900,330,-540>}

// ceiling
        box { <660,880,-1860>,
              <-1800,905,800>
              texture { pigment { color CeilingColor}}
            }

#declare Burgundy =rgb <0.325, 0.193, 0.2>;
#declare PaleBurgundy=rgb <0.4,.25,.259>;

plane { y,-150
            texture {
                pigment { checker  
                    pigment { gradient z 
                                color_map {
                                    [0 Gray60]
                                    [.2 rgb <.5,.5,.3>]
                                    [.25 PaleBurgundy]
                                    [.8 PaleBurgundy]
                                    [.87 DarkGreen]
                                    [1 DarkGreen]
                                    }
                              scale .3
                              turbulence 0.1
                             }
                     pigment { color Burgundy
                              }
                     scale 2
                     turbulence 0.015
                       }
               normal { quilted control0 .875 control1 .7 rotate y*45 scale <2,1.5,2> turbulence 0.02}
                     }
                   
           }

#declare YOfs=-100+(-FrontHeight+0.7501)*22;

#ifndef (skip)
	#ifndef (skiptree)
		#include "T_Tree.inc"
		#object {T_Tree scale <4.5,7.5,4.5> translate <-270,YOfs,125>
        		 } 
    #else
    	#declare R=seed(123);
	#end
	#ifndef (skipgrass)
		#include "grasscl.inc"

		object { MakeClump(1) scale 2.5 translate <-298,YOfs,140>}
		object { MakeClump(1) scale 2.5 translate <-294,YOfs,144>}
		object { MakeClump(1) scale 2.5 translate <-290,YOfs,148>}
		object { MakeClump(1) scale 2.5 translate <-288,YOfs,153>}
		object { MakeClump(1) scale 2.5 translate <-286,YOfs,158>}
		object { MakeClump(1) scale 2.5 translate <-288,YOfs,163>}
		object { MakeClump(1) scale 2.5 translate <-290,YOfs,168>}
		object { MakeClump(1) scale 2.5 translate <-294,YOfs,172>}
		object { MakeClump(1) scale 2.5 translate <-298,YOfs,176>}
		
		object { MakeClump(1) scale 2.5 translate <-298,YOfs,158>}
		object { MakeClump(1) scale 2.5 translate <-294,YOfs,162>}
		object { MakeClump(1) scale 2.5 translate <-288,YOfs,171>}
		object { MakeClump(1) scale 2.5 translate <-286,YOfs,176>}
		object { MakeClump(1) scale 2.5 translate <-288,YOfs,181>}
		object { MakeClump(1) scale 2.5 translate <-290,YOfs,186>}
		object { MakeClump(1) scale 2.5 translate <-294,YOfs,190>}
		object { MakeClump(1) scale 2.5 translate <-298,YOfs,194>}
		
		object { MakeClump(1) scale 2.5 translate <-294,YOfs,180>}
		object { MakeClump(1) scale 2.5 translate <-288,YOfs,189>}
		object { MakeClump(1) scale 2.5 translate <-286,YOfs,194>}
		object { MakeClump(1) scale 2.5 translate <-288,YOfs,199>}
		object { MakeClump(1) scale 2.5 translate <-290,YOfs,204>}
		object { MakeClump(1) scale 2.5 translate <-294,YOfs,208>}
		object { MakeClump(1) scale 2.5 translate <-298,YOfs,212>}

        #declare L1=0;
        #declare XB=-275;
        #declare ZB=210;
        #while (L1<25)
            #declare JSx=rand(R)*.4-.2;
            #declare JSz=rand(R)*.4-.2;
            #declare JSy=rand(R)*.3-.15;
            #declare JX=rand(R)*1-.5;
            #declare JZ=rand(R)*2-1.5;
            
            object { MakeClump(2) scale <2+JSx,1.35+JSy,2+JSz> translate <XB+JX,YOfs,ZB+JZ>}
            #if (ZB=210)
                #declare ZB=205;
            #else
                #declare ZB=210;
            #end
            #declare XB=XB+3; 
            #declare L1=L1+1;
        #end
	#end
#else
	#declare R=seed(123);
#end                  

// flower beds

#include "DO_Tulips.inc"  
  
#declare L1=-160;
#declare L2B=140;
#while (L1>-191) 
	#declare L2O=75-(abs(L1)-130)/4;
	#declare L2=L2B-L2O;
	#while (L2<L2B+L2O)
		#declare JX=rand(R)*.2-.1;
		#declare JZ=rand(R)*.15-.075;
		#declare Typ=rand(R);
		#declare Col=rand(R);
		#switch (Col)
			#range (0,0.5)
				#declare Col=4;
				#break
			#range (0.5,0.75)
				#declare Col=1;
				#break
			#range (0.75,0.9)
				#declare Col=0;
				#break
			#else
				#declare Col=3;
		#end                               
		#declare JS=rand(R)*3;
        #if (Typ<.38)
			#declare JR=rand(R)*30-15;
        	object {DO_Tulip(Col) scale 17+JS rotate JR*y translate <L1+JX,YOfs+5,L2+JZ> }
        	sphere {<0,0,0> 1 translate <L1+JX,YOfs+5,L2+JZ> pigment {rgb <1,1,1>}} 
       	#else
       		#if (rand(R)>.925)
       			#declare JR=rand(R)*180+90;
       		#else                                    
       			#declare JR=rand(R)*140-70;
       		#end
	      	object {DO_TulipLeaning(Col) scale 17+JS rotate JR*y translate <L1+JX,YOfs+4,L2+JZ> }
        #end
    	#declare L2=L2+4;
    #end
    #declare L1=L1-5;
#end

#include "DO_Flowers1.inc"

object {DO_Flower4 scale 5 translate <-120,YOfs+4,210>  }
object {DO_Flower4 scale 5.2 rotate y*15 translate <-130,YOfs+4,210>}
object {DO_Flower4X scale 4.68 rotate y*27 translate <-120.1,YOfs+4,200>}
object {DO_Flower4 scale 5.1 rotate y*172 translate <-129.9,YOfs+4,200>}
object {DO_Flower4X scale 4.45 rotate y*91 translate <-120,YOfs+4,190.2>}
object {DO_Flower4X scale 5.35 rotate y*23 translate <-130,YOfs+4,190>}
object {DO_Flower4 scale 5.1 rotate y*232 translate <-119.87,YOfs+4,180>}
object {DO_Flower4 scale 4.77 rotate y*-20 translate <-130,YOfs+4,180.4>}
object {DO_Flower4 scale 5.18 rotate y*-54 translate <-120,YOfs+4,170>}
object {DO_Flower4X scale 5 rotate y*11 translate <-130,YOfs+4,170>}

#declare GrassP1=texture {pigment 
                            {   bozo
                                color_map {
                                [0 rgbt <.1,.75,0,0.1> ]
                                [0.15 rgbt <.03,.67,0,0.05> ]
                                [0.17 rgbt <1,1,1,1> ]
                                [0.23 rgbt <1,1,1,1> ]
                                [0.25 rgbt <.1,.75,0,0.1> ]
                                [0.45 rgbt <.03,.67,0,0.05> ]
                                [0.47 rgbt <1,1,1,1> ]
                                [0.55 rgbt <1,1,1,1> ]
                                [0.57 rgbt <.03,.7,0,.1>]
                                [0.75 rgbt <0,.6,0,.07>]
                                [0.77 rgbt <1,1,1,1> ]
                                [0.88 rgbt <1,1,1,1> ]
                                [0.91 rgbt <.03,.7,0,.1>]
                                [1    rgbt <0,.6,0,.07>]
                                        }
                                scale .15
                                turbulence .15
                                }
                           }

#declare Lawn1=union {
                box { <-195,YOfs,80>,
                      <-230,YOfs+3,140>
                    }
                cylinder {<0,0,0>,<0,3,0>,10 scale <1,1,2> translate <-224,YOfs,110>}
                difference {
                    box { <-246,YOfs,80>,
                          <-276,YOfs+3,200>
                        }
                    cylinder { <0,-0.01,0>,<0,3.01,0>,10 scale <1.35,1,2> translate <-277,YOfs,120>}
                    }
                box { <-276,YOfs,200>,
                      <-195,YOfs+3,150>
                    }
                cylinder { <-195,YOfs,80>,<-195,YOfs,140>, 3}
                cylinder { <-195,YOfs,80>,<-230,YOfs,80>, 3}
                cylinder { <-230,YOfs,80>,<-230,YOfs,140>, 3}
                torus    { 10,3 scale <1,1,2> translate <-224,YOfs,110>}
                cylinder { <-230,YOfs,80>,<-195,YOfs,80>, 3}
                cylinder { <-276,YOfs,200>,<-276,YOfs,140>, 3}
                cylinder { <-276,YOfs,150>,<-195,YOfs,150>, 3}
                cylinder { <-276,YOfs,200>,<-195,YOfs,200>, 3}
                cylinder { <-246,YOfs,80>,<-246,YOfs,201>, 3}
                cylinder { <-195,YOfs,200>,<-195,YOfs,150>, 3}
                sphere {<-276,YOfs,200>,3}
                sphere {<-195,YOfs,200>,3}                
                sphere {<-195,YOfs,150>,3}                
                texture { GrassP1 }
          }                
                    
                    
Lawn1
#declare L1=0;
#while (L1<18)
    #declare JX=rand(R)*70-273;
    #declare Typ=rand(R);
    #declare JZ=rand(R)*44+153;
    #declare JS=rand(R)-0.5;
    #declare JR=rand(R)*360;
     #switch (Typ)
        #range (0,0.38)
            object {PatchOfWhiteFlowers scale 5+JS rotate JR*y translate <JX,YOfs+5,JZ>}
            #break
        #range (0.38,0.76)
            object {PatchOfBlueFlowers scale 5+JS rotate JR*y translate <JX,YOfs+5,JZ>}
            #break
        #range (0.76,0.84)
            object {DO_Flower1 scale 5+JS rotate JR*y translate <JX,YOfs+5,JZ>}
            #break
        #range (0.84,0.92)
            object {DO_Flower2 scale 5+JS rotate JR*y translate <JX,YOfs+5,JZ>}
            #break
        #range (0.92,0.96)
            object {DO_Flower1L scale 5+JS rotate JR*y translate <JX,YOfs+5,JZ>}
            #break
        #else
            object {DO_Flower2L scale 5+JS rotate JR*y translate <JX,YOfs+5,JZ>}
    #end
    #declare L1=L1+1;
#end

#declare L1=0;
#while (L1<10)
    #declare JX=rand(R)*24-227;
    #declare Typ=rand(R);
    #declare JZ=rand(R)*54+83;
    #declare JS=rand(R)-0.5;
    #declare JR=rand(R)*360;
     #switch (Typ)
        #range (0,0.38)
            object {PatchOfWhiteFlowers scale 5+JS rotate JR*y translate <JX,YOfs+5,JZ>}
            #break
        #range (0.38,0.76)
            object {PatchOfBlueFlowers scale 5+JS rotate JR*y translate <JX,YOfs+5,JZ>}
            #break
        #range (0.76,0.84)
            object {DO_Flower1 scale 5+JS rotate JR*y translate <JX,YOfs+5,JZ>}
            #break
        #range (0.84,0.92)
            object {DO_Flower2 scale 5+JS rotate JR*y translate <JX,YOfs+5,JZ>}
            #break
        #range (0.92,0.96)
            object {DO_Flower1L scale 5+JS rotate JR*y translate <JX,YOfs+5,JZ>}
            #break
        #else
            object {DO_Flower2L scale 5+JS rotate JR*y translate <JX,YOfs+5,JZ>}
    #end
    #declare L1=L1+1;
#end

