// T_Tree include file
// generates an evergreen tree
//
// Brendt W. Hess, 1999
// Released to the public domain - modify to your heart's content.
//
//  enjoy!
//

#local Height = 2;
#local Radius = Height*.02;

#ifndef(R)
    #declare R = seed(123);
#end

#local T_BranchTexture = texture {
   pigment { bozo
             turbulence .5
             color_map {
                [0      rgb <.6, .5, .4> ]
                [0.1    rgb <.36,.25,.2> ]
                [0.35   rgb <.36,.2,.1> ]  
                [0.55   rgb <.35,.35,.35> ]
                [0.75   rgb <.48,.35,.25> ]
                [0.82   rgb <.54, .51, .464> ]
                [0.95   rgb <.5,.41,.32>]
                [1      rgb <.54,.47,.37>]
                }
             scale <.04,.12,.03>
                }
   normal { bumps .3 scale <.01,.05,.01> }
   finish {ambient 0.25}
   }

#declare T_Trunk=union {
    cone { <0,0,0>, .5, <0,.15,0>,.45 }
    cone { <.31,.1,0>,.1, <.69,-.2.0>, .05 scale <1,1,1.4>}
    cone { <0,.15,0>, .45, <0,.25,0>,.43}
    cone { <0,.25,0>,.43, <0,.4,0>,.4}
    cone { <0,.4,0>,.4, <0,.8,0>,.35}
    cone { <0,.8,0>,.35, <0,1.6,0>,.3}
    cone { <0,1.6,0>,.3, <0,3.8,0>,.275}
    cone { <0,3.8,0>, .275, <0,7,0>,.11}
    texture { T_BranchTexture } 
    }
                         
#declare T_Needle=cylinder { <0,0,0>, <.164,0,0> .018 
                    scale <1,.13,1>
                    rotate <0,0,36>
                    texture { pigment { color rgb <0.1,.52,0.33> } 
                        finish {ambient 0.2
                           specular 0.18
                            diffuse 0.4
                            metallic 0.25}
                        }
                    }

#declare T_LBr=array[10]
#local NN=0;
#while (NN<10)
    #declare T_LBr[NN]=union {
    cone { <0,0,0>, Radius*.25, <0,Height/2.3,0>, Radius*.1
        texture { T_BranchTexture scale .25} }
        
    intersection {
        box { <-.5,-0.01,-1.65>,<.5,0.01,1.65>}
        box {<-1.75,-0.0101,-1.3>, <1.75,0.0101,1.3>
                rotate y*25}
        texture {
            pigment {
                gradient z
                color_map { [0      rgbt <1,1,1,1>]
                            [0.2    rgbt <1,1,1,1>]
                            [0.25   rgb <0.1,.52,0.33>]
                            [0.75   rgb <0.1,.52,0.33>]
                            [0.8    rgbt <1,1,1,1>]
                            [1      rgbt <1,1,1,1>]
                          }
                triangle_wave
                rotate y*25
                scale .2
                turbulence .1
                }
                finish {ambient 0.2
                        specular 0.18
                        diffuse 0.4
                        metallic 0.25}
            } 
        translate <.5,0,-1.65> 
        scale .16
        rotate x*90
        translate <0,.41,0>
 }
    intersection {
        box { <-.5,-.01,-1.65>,<.5,.01,1.65>}
        box {<-1.75,-.0101,-1.3>, <1.75,.0101,1.3>
                rotate y*25}
        texture {
            pigment {
                gradient z
                color_map { [0      rgbt <1,1,1,1>]
                            [0.2    rgbt <1,1,1,1>]
                            [0.25   rgbt <0,.5,0,0.1>]
                            [0.75   rgbt <0,.5,0,0.1>]
                            [0.8    rgbt <1,1,1,1>]
                            [1      rgbt <1,1,1,1>]
                          }
                triangle_wave
                rotate y*25
                scale .2
                turbulence .1
                }
                finish {ambient 0.25}
            } 
        translate <.5,0,-1.65> 
        scale .16
        rotate x*90         
        translate <0,.41,0>
        rotate y*180
 }
    #local Num=1;
    #while (Num<6)
        #local JH=rand(R)*6-3;
        object { T_Needle rotate <0,0,Num*18+JH> translate <0,Height/2.3,0>}
        #local Num=Num+1;
    #end

}      
    #local NN=NN+1;
#end

// Medium branches - several little branches included

#declare T_MBr=array[10]
#local NB=0;
#while (NB<10)
    #declare T_MBr[NB]=union {
        cone { <0,0,0>,Radius, <0,1.5,0>, Radius*.3
            texture {T_BranchTexture scale 0.5}
             }
        #local Num=0;
        #while (Num<4)
            #local NN=int(rand(R)*9.999);
            #local JX=rand(R)*8-4;       
            #local JY=rand(R)*Height/15-Height/30;
            #local JZ=rand(R)*15-7.5;
            #local JS=rand(R)/10+.95;
            object { T_LBr[NN] scale <1,JS,1> rotate <0,JX,65+JZ> translate <0,1.5-(Num*Height/6)+JY,0> } 
            #local NN=int(rand(R)*9.999); 
            #local JX=rand(R)*8-4;       
            #local JY=rand(R)*Height/15-Height/30;
            #local JZ=rand(R)*15-7.5;
            #local JS=rand(R)/10+.95;
            object { T_LBr[NN] scale <1,JS,1> rotate <0,JX,JZ-65> translate <0,1.5-(Num*Height/6)+JY,0> }
            #local Num=Num+1;
        #end
        #local NN=int(rand(R)*9.999);
        #local JX=rand(R)*6-3;
        #local JZ=rand(R)*9-4.5;
        object {T_LBr[NN] rotate<JX,0,JZ> translate <0,1.5,0>}
    }
    #local NB=NB+1;
#end

// Final Branch - several Medium Branches per branch

#declare T_BBr=array[8]
#local BN=0;
#local Num=0;

#while (BN<8)
    #declare T_BBr[BN]=union {
        cone { <0,0,0> .11 <0,3,0> .04
                texture {T_BranchTexture}
             }
        #local NN=0;
        #local Stp=2+int(rand(R)*2.99);
        #while (NN<Stp)
            #local NB=int(rand(R)*9.99);
            #local JR=rand(R)*15;
            #local JY=rand(R)*10-5;
            #local JZ=rand(R)*8-4;
            #local Ofs=(3-(Stp-NN)/2)-rand(R)*(Stp/15);
            object { T_MBr[NB] rotate z*65+JR rotate <0,JY,JZ> translate <0,Ofs,0> }
            #local NB=int(rand(R)*9.99);
            #local JR=rand(R)*15;
            #local JY=rand(R)*10-5;
            #local JZ=rand(R)*8-4;
            #local Ofs=(3-(Stp-NN)/2)-rand(R)*(Stp/15);
            object { T_MBr[NB] rotate z*65+JR rotate <0,JY+180,JZ> translate <0,Ofs,0> }
            #local NN=NN+1;
        #end
        #local NB=int(rand(R)*9.99);
        #local JR=rand(R)*10-5;
        #local JY=rand(R)*10-5;
        object { T_MBr[NB] rotate z*JR rotate y*JY translate <0,3,0>}
    }
    #local BN=BN+1;
#end 

#local Num=0;
#local Rot=0;
#local Ofs=2;
#local OfsStep=0.3;
#local OfsMax=7;
#local BCt=0;
#local BPtr=array[20][2]
#local RPtr=array[20]
#local SelPtr=array[20]


#declare T_Tree=union {

#while (Ofs+Num<OfsMax) //OfsMax)          
    #local BPtr[BCt][0]=int(rand(R)*7.99);
    #local JR=rand(R)*10-5+84-Num*3;
    #local Scale=1-(Num/((OfsMax-Ofs)*1.6));
    #local Opt=rand(R)+Num/50;
    #if (Num>4)
        #local Opt=0;
    #end

    #if (Opt<(Num*Num/20))
        #local BPtr[BCt][1]=1;
    #else
        #local BPtr[BCt][1]=0;
    #end
    #local RPtr[BCt]=Rot;
    #local SelPtr[BCt]=Num;
    #local Num=Num+rand(R)*.14+.02;
    #local Rot=Rot+rand(R)*60+rand(R)*60;
    
    #if (Rot>=360 | Num+Ofs>=OfsMax)     
        #local Ix=0;
        #while (Ix<=BCt)
            #local JR=rand(R)*6-3+84-Num*3;
            #local Scale=1-(Num/((OfsMax-Ofs)*1.6));
            #local Bx=int(rand(R)*(BCt+.999));
            #while (BPtr[Bx][1]<0)
                #local Bx=int(rand(R)*(BCt+.999));
            #end
            #local Rx=int(rand(R)*(BCt+.999));
            #while (RPtr[Rx]<0)
                #local Rx=int(rand(R)*(BCt+.999));
            #end

            #if (BPtr[Bx][1]=1)
                #if (SelPtr[Bx]<4)
                    #local Scale=1;
                #else
                    #local Scale=1-(SelPtr[Bx]-4)/3;
                #end
                object { T_MBr[BPtr[Bx][0]] rotate x*JR rotate y*RPtr[Rx] scale Scale translate <0,SelPtr[Bx]+Ofs,0> }                
            #else
                #local Scale=1-(SelPtr[Bx]/((OfsMax-Ofs)*1.6));
                object { T_BBr[BPtr[Bx][0]] rotate x*JR scale Scale rotate y*RPtr[Rx] translate < 0,SelPtr[Bx]+Ofs,0> }
            #end
            #local Ix=Ix+1;
            #local BPtr[Bx][1]=-1;
            #local RPtr[Rx]=-1;
        #end
        #local Rot=Rot-360;
        #local Num=Num+rand(R)*.22+.04;
        #local BCt=0;
    #else
        #local BCt=BCt+1;
    #end
    #debug concat (str(Num,2,3),":",str(Rot,3,3),"\n")
#end            
object { T_Trunk }
}
